diff -uNr linux/drivers/ssi/adc1213x.h linux-2.4.7/drivers/ssi/adc1213x.h
--- linux/drivers/ssi/adc1213x.h	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/drivers/ssi/adc1213x.h	Thu Aug  2 03:02:59 2001
@@ -0,0 +1,104 @@
+/*
+ * linux/include/asm-arm/arch-clps7110/adc1213x.h
+ *
+ * Written 1999 by Werner Almesberger
+ *
+ * NS ADC1213X interface
+ */
+
+#ifndef __ASM_ARCH_ADC1213X_H
+#define __ASM_ARCH_ADC1213X_H
+
+#include <linux/types.h>
+#include <asm/atomic.h>
+
+
+#define ADC1213X_CHANNELS	8	/* ADC12138 */
+
+/*
+ * All times are in microseconds.
+ *
+ * The following timing parameters depend on the environment:
+ *
+ * ADC1213X_T_CK	conversion clock cycle time
+ * ADC1213X_T_SK	serial data clock cycle time
+ */
+
+#define ADC1213X_T_C	(44*ADC1213X_T_CK)	/* Conversion Time */
+#define ADC1213X_T_A_6	(7*ADC1213X_T_CK)	/* Acquisition Time */
+#define ADC1213X_T_A_10	(11*ADC1213X_T_CK)
+#define ADC1213X_T_A_18	(19*ADC1213X_T_CK)
+#define ADC1213X_T_A_34	(35*ADC1213X_T_CK)
+#define ADC1213X_T_CAL	(4944*ADC1213X_T_CK)	/* Self-Calibration Time */
+#define ADC1213X_T_AZ	(76*ADC1213X_T_CK)	/* Auto-Zero Time */
+#define ADC1213X_T_DOR	(9*ADC1213X_T_SK)	/* DOR High Time */
+#define	ADC1213X_T_CONV	(8*ADC1213X_T_SK)	/* CONV valid time */
+#define ADC1213X_T_SPU	700			/* Software Power-Up Time */
+
+#define	ADC1213X_CONV(chan,flags)	(((chan) << 1) | (flags))
+#define ADC1213X_FLG_DIFF	0x00		/* Differential */
+#define ADC1213X_FLG_SNGL	0x01		/* Single-Ended */
+#define ADC1213X_FLG_12		0x00		/* 12/13 bit conversion */
+#define ADC1213X_FLG_16		0x80		/* 16/17 bit conversion */
+#define ADC1213X_FLG_LSB	0x20		/* LSB first */
+#define ADC1213X_FLG_MSB	0x00		/* MSB first */
+
+#define ADC12130_CMD(cmd)	((cmd & 0x03) | ((cmd & 0xf0) >> 2))
+
+#define ADC1213X_CAL		0x10		/* Auto Cal */
+#define	ADC1213X_AZ		0x90		/* Auto Zero */
+#define ADC1213X_PWUP		0x50		/* Power Up */
+#define ADC1213X_PWDN		0xd0		/* Power Down */
+#define ADC1213X_STATUS		0x30		/* Read Status Register */
+#define ADC1213X_DATA_U		0xb0		/* Data Out without Sign */
+#define ADC1213X_DATA_S		0xb1		/* Data Out with Sign */
+#define ADC1213X_ACQ6		0x70		/* Acquisition Time - 6 CCLK */
+#define ADC1213X_ACQ10		0x72		/* Acquisition Time - 10 CCLK */
+#define ADC1213X_ACQ18		0x71		/* Acquisition Time - 18 CCLK */
+#define ADC1213X_ACQ34		0x73		/* Acquisition Time - 34 CCLK */
+
+#define ADC1213X_CHAN0		0
+#define ADC1213X_CHAN1		1
+#define ADC1213X_CHAN2		4
+#define ADC1213X_CHAN3		5
+#define ADC1213X_CHAN4		2
+#define ADC1213X_CHAN5		3
+#define ADC1213X_CHAN6		6
+#define ADC1213X_CHAN7		7
+
+
+/*
+ * "before_adc" and "after_adc" are called before of after the ADC hardware
+ * does a conversion. "result" is called when the conversion result is
+ * available. If A and B are two requests and A < B means that A is enqueued
+ * before B, the following partial order applies:
+ *
+ * A->before_adc < A->after_adc	("after_adc" follows "before_adc")
+ * A->after_adc < B->before_adc	(requests don't overlap)
+ * A->after_adc < A->result	("result" is always last)
+ * A->result < B->result	(no reordering)
+ *
+ * However, note that you must NOT assume any of
+ *
+ * A->result < B->before_adc
+ * A->result < B->after_adc
+ *
+ * "before_adc", "before_adc", and "result" can be set to NULL if not used.
+ */
+
+struct adc_req {
+	/* ----- initialized by the user ----------------------------------- */
+	int channel;
+	void (*before_adc)(struct adc_req *req);
+	void (*after_adc)(struct adc_req *req);
+	void (*result)(struct adc_req *req,uint16_t data);
+	void *user;
+	/* ----- initialized by adc_request -------------------------------- */
+	struct adc_req *next;
+};
+
+
+void adc_request(struct adc_req *req);
+void adc_init(int cycles);
+
+#endif
diff -uNr linux/drivers/video/clps711xfb.c linux-2.4.7/drivers/video/clps711xfb.c
--- linux/drivers/video/clps711xfb.c	Fri Aug  3 05:40:03 2001
+++ linux-2.4.7/drivers/video/clps711xfb.c	Sun Dec  2 08:01:35 2001
@@ -17,7 +17,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  Framebuffer driver for the CLPS7111 and EP7212 processors.
+ *  Framebuffer driver for the CLPS711X and EP7212 processors.
  */
 #include <linux/module.h>
 #include <linux/kernel.h>
@@ -31,10 +31,13 @@
 #include <asm/hardware.h>
 #include <asm/mach-types.h>
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
+
+#if defined(CONFIG_ARCH_P720T)
 #include <asm/arch/syspld.h>
+#endif
 
-static struct clps7111fb_info {
+static struct clps711xfb_info {
 	struct fb_info		fb;
 	int			currcon;
 } *cfb;
@@ -45,7 +48,7 @@
  *    Set a single color register. Return != 0 for invalid regno.
  */
 static int
-clps7111fb_setcolreg(u_int regno, u_int red, u_int green, u_int blue,
+clps711xfb_setcolreg(u_int regno, u_int red, u_int green, u_int blue,
 		     u_int transp, struct fb_info *info)
 {
 	unsigned int level, mask, shift, pal;
@@ -74,10 +77,10 @@
  * Set the colormap
  */
 static int
-clps7111fb_set_cmap(struct fb_cmap *cmap, int kspc, int con,
+clps711xfb_set_cmap(struct fb_cmap *cmap, int kspc, int con,
 		    struct fb_info *info)
 {
-	struct clps7111fb_info *cfb = (struct clps7111fb_info *)info;
+	struct clps711xfb_info *cfb = (struct clps711xfb_info *)info;
 	struct fb_cmap *dcmap = &fb_display[con].cmap;
 	int err = 0;
 
@@ -86,7 +89,7 @@
 		err = fb_alloc_cmap(dcmap, CMAP_SIZE, 0);
 
 	if (!err && con == cfb->currcon) {
-		err = fb_set_cmap(cmap, kspc, clps7111fb_setcolreg, &cfb->fb);
+		err = fb_set_cmap(cmap, kspc, clps711xfb_setcolreg, &cfb->fb);
 		dcmap = &cfb->fb.cmap;
 	}
 
@@ -100,7 +103,7 @@
  *    Set the User Defined Part of the Display
  */
 static int
-clps7111fb_set_var(struct fb_var_screeninfo *var, int con,
+clps711xfb_set_var(struct fb_var_screeninfo *var, int con,
 		   struct fb_info *info)
 {
 	struct display *display;
@@ -215,7 +218,7 @@
 	clps_writel(lcdcon, LCDCON);
 	clps_writel(syscon | SYSCON1_LCDEN, SYSCON1);
 
-	fb_set_cmap(&cfb->fb.cmap, 1, clps7111fb_setcolreg, &cfb->fb);
+	fb_set_cmap(&cfb->fb.cmap, 1, clps711xfb_setcolreg, &cfb->fb);
 
 	return 0;
 }
@@ -250,18 +253,18 @@
 	return 0;
 }
 
-static struct fb_ops clps7111fb_ops = {
+static struct fb_ops clps711xfb_ops = {
 	owner:		THIS_MODULE,
-	fb_set_var:	clps7111fb_set_var,
-	fb_set_cmap:	clps7111fb_set_cmap,
+	fb_set_var:	clps711xfb_set_var,
+	fb_set_cmap:	clps711xfb_set_cmap,
 	fb_get_fix:	gen_get_fix,
 	fb_get_var:	gen_get_var,
 	fb_get_cmap:	gen_get_cmap,
 };
 
-static int clps7111fb_switch(int con, struct fb_info *info)
+static int clps711xfb_switch(int con, struct fb_info *info)
 {
-	struct clps7111fb_info *cfb = (struct clps7111fb_info *)info;
+	struct clps711xfb_info *cfb = (struct clps711xfb_info *)info;
 	struct display *disp;
 	struct fb_cmap *cmap;
 
@@ -294,17 +297,17 @@
 	cfb->fb.var = disp->var;
 	cfb->fb.var.activate = FB_ACTIVATE_NOW;
 
-	clps7111fb_set_var(&cfb->fb.var, con, &cfb->fb);
+	clps711xfb_set_var(&cfb->fb.var, con, &cfb->fb);
 
 	return 0;
 }
 
-static int clps7111fb_updatevar(int con, struct fb_info *info)
+static int clps711xfb_updatevar(int con, struct fb_info *info)
 {
 	return -EINVAL;
 }
 
-static void clps7111fb_blank(int blank, struct fb_info *info)
+static void clps711xfb_blank(int blank, struct fb_info *info)
 {
 }
 
@@ -321,7 +324,7 @@
 
 	cfb->currcon		= -1;
 
-	strcpy(cfb->fb.fix.id, "clps7111");
+	strcpy(cfb->fb.fix.id, "clps711x");
 	cfb->fb.screen_base	= (void *)PAGE_OFFSET;
 	cfb->fb.fix.smem_start	= PAGE_OFFSET;
 	cfb->fb.fix.smem_len	= 0x14000;
@@ -337,11 +340,11 @@
 	cfb->fb.var.height	= -1;
 	cfb->fb.var.width	= -1;
 
-	cfb->fb.fbops		= &clps7111fb_ops;
+	cfb->fb.fbops		= &clps711xfb_ops;
 	cfb->fb.changevar	= NULL;
-	cfb->fb.switch_con	= clps7111fb_switch;
-	cfb->fb.updatevar	= clps7111fb_updatevar;
-	cfb->fb.blank		= clps7111fb_blank;
+	cfb->fb.switch_con	= clps711xfb_switch;
+	cfb->fb.updatevar	= clps711xfb_updatevar;
+	cfb->fb.blank		= clps711xfb_blank;
 	cfb->fb.flags		= FBINFO_FLAG_DEFAULT;
 	cfb->fb.disp		= (struct display *)(cfb + 1);
 
@@ -350,14 +353,17 @@
 	/*
 	 * Power up the LCD
 	 */
-	if (machine_is_p720t()) {
-		PLD_LCDEN = PLD_LCDEN_EN;
-		PLD_PWR |= (PLD_S4_ON|PLD_S3_ON|PLD_S2_ON|PLD_S1_ON);
-	}
+#if defined(CONFIG_ARCH_P720T)
+	PLD_LCDEN = PLD_LCDEN_EN;
+	PLD_PWR |= (PLD_S4_ON|PLD_S3_ON|PLD_S2_ON|PLD_S1_ON);
+#endif
 
-	clps7111fb_set_var(&cfb->fb.var, -1, &cfb->fb);
+	clps711xfb_set_var(&cfb->fb.var, -1, &cfb->fb);
 	err = register_framebuffer(&cfb->fb);
-
+	if(err < 0)
+		printk(KERN_ERR "clps711xfb.c: register_framebuffer failed\n");
+	else
+		printk(KERN_ERR "CLPS711X framebuffer\n");
 out:	return err;
 }
 
@@ -369,10 +375,10 @@
 	/*
 	 * Power down the LCD
 	 */
-	if (machine_is_p720t()) {
-		PLD_LCDEN = 0;
-		PLD_PWR &= ~(PLD_S4_ON|PLD_S3_ON|PLD_S2_ON|PLD_S1_ON);
-	}
+#if defined(CONFIG_ARCH_P720T)
+	PLD_LCDEN = 0;
+	PLD_PWR &= ~(PLD_S4_ON|PLD_S3_ON|PLD_S2_ON|PLD_S1_ON);
+#endif
 }
 
 #ifdef MODULE
diff -uNr linux/include/asm-arm/arch-clps711x/dma.h linux-2.4.7/include/asm-arm/arch-clps711x/dma.h
--- linux/include/asm-arm/arch-clps711x/dma.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/dma.h	Wed Apr 17 16:42:28 2002
@@ -24,5 +24,9 @@
 
 #define MAX_DMA_CHANNELS	0
 
+void clps7110_adjust_zones(int node, unsigned long *zone_size, unsigned long *zhole_size);
+
+#define arch_adjust_zones(node,size,holes) clps7110_adjust_zones(node,size,holes)
+
 #endif /* _ASM_ARCH_DMA_H */
 
diff -uNr linux/include/asm-arm/arch-clps711x/etna.h linux-2.4.7/include/asm-arm/arch-clps711x/etna.h
--- linux/include/asm-arm/arch-clps711x/etna.h	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/include/asm-arm/arch-clps711x/etna.h	Fri Aug 10 00:02:24 2001
@@ -0,0 +1,43 @@
+/*
+ *  linux/include/asm-arm/arch-clps711x/etna.h
+ *
+ *  Psion Series 5 ETNA controller register definitions.
+ *
+ *  Copyright (C) 2000 Deep Blue Solutions Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#ifndef __ASM_ARCH_ETNA_H
+#define __ASM_ARCH_ETNA_H
+
+#define ETNA_PHYS_BASE		(0x20000000)
+#define ETNA_SIZE		(0x00100000)
+
+#ifndef __ASSEMBLY__
+#include <asm/types.h>
+
+#define ETNA_REG(type,off)	(*(volatile type *)(ETNA_BASE + off))
+#else
+#define ETNA_REG(type,off)	(off)
+#endif
+
+#define	ETNA_CF_IRQ		0x01			/* Card Interrupt */
+
+#define ETNA_INT_STATUS		ETNA_REG(u8,  6)	/* Interrupt Status */
+#define ETNA_INT_MASK		ETNA_REG(u8,  7)	/* Interrupt Mask */
+#define ETNA_INT_CLEAR		ETNA_REG(u8,  8)	/* Interrupt Clear */
+#define ETNA_CONTROL		ETNA_REG(u8, 11)	/* CF control */
+
+#endif
diff -uNr linux/include/asm-arm/arch-clps711x/hardware.h linux-2.4.7/include/asm-arm/arch-clps711x/hardware.h
--- linux/include/asm-arm/arch-clps711x/hardware.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/hardware.h	Wed Apr 17 03:39:41 2002
@@ -22,14 +22,32 @@
 #ifndef __ASM_ARCH_HARDWARE_H
 #define __ASM_ARCH_HARDWARE_H
 
-#define CLPS7111_VIRT_BASE	0xff000000
-#define CLPS7111_BASE		CLPS7111_VIRT_BASE
+#define CLPS711X_VIRT_BASE	0xff000000
+#define CLPS711X_BASE		CLPS711X_VIRT_BASE
 
-#define EP7212_VIRT_BASE	CLPS7111_VIRT_BASE
-#define EP7212_BASE		CLPS7111_VIRT_BASE
+#define EP7212_VIRT_BASE	CLPS711X_VIRT_BASE
+#define EP7212_BASE		CLPS711X_VIRT_BASE
+
+#if defined(CONFIG_PCMCIA_ETNA)
+
+#define ETNA_VIRT_BASE		0xfe000000
+#define ETNA_BASE		ETNA_VIRT_BASE
+
+#include "etna.h"
+
+#define PCMCIA_VIRT_BASE	0xe0000000
+#define PCMCIA_BASE		PCMCIA_VIRT_BASE
+
+#define PCMCIA_SIZE		0x10000000	/* 4 areas of 64MB each */
+
+#endif /* defined(CONFIG_PCMCIA_ETNA) */
+
+#if defined(CONFIG_ARCH_P720T)
 
 #define SYSPLD_VIRT_BASE	0xfe000000
 #define SYSPLD_BASE		SYSPLD_VIRT_BASE
+
+#endif /* defined(CONFIG_ARCH_P720T) */
 
 #ifndef __ASSEMBLER__
 
diff -uNr linux/include/asm-arm/arch-clps711x/hw_psion.h linux-2.4.7/include/asm-arm/arch-clps711x/hw_psion.h
--- linux/include/asm-arm/arch-clps711x/hw_psion.h	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/include/asm-arm/arch-clps711x/hw_psion.h	Wed Nov 28 04:06:53 2001
@@ -0,0 +1,114 @@
+/*
+ * linux/include/asm/arch/hw_psion.h
+ *
+ * Written 1998,1999 by Werner Almesberger
+ *
+ * This file contains the hardware definitions of the Psion S5
+ */
+
+#ifndef __ASM_ARCH_HW_PSION_H
+#define __ASM_ARCH_HW_PSION_H
+
+/*
+ * Physical address of PCMCIA area. Actually it's CF, but they're accessed in
+ * the same way.
+ */
+
+#define PCMCIA_START		0x40000000
+
+/*
+ * LCD display size
+ */
+
+#define LCD_X_SIZE		640
+#define LCD_Y_SIZE		240
+
+/*
+ * Register/port usage
+ */
+
+/*
+ * Port B
+ *
+ * +--7--+--6--+--5--+--4--+--3--+--2--+--1--+--0--+
+ * |VPCEN|OPEN |VLDD3|VLDD2|VLDD1|VLDD0|EECLK|EECS |
+ * | out |in/ou|in/ou|in/ou|in/ou|in/ou| out | out |
+ * +-----+-----+-----+-----+-----+-----+-----+-----+
+ */
+
+#define HW_VLD_MASK		0x3c	/* Contrast control */
+#define HW_VLD_SHIFT		2
+#define HW_OPEN_BIT		0x40	/* Indicates that the case is open */
+#define HW_VPCEN_BIT		0x80	/* Enables the power to the CF Card */
+
+/*
+ * Port C
+ *
+ * +--7--+--6--+--5--+--4--+--3--+--2--+--1--+--0--+
+ * |ADICT|BBLD |IREN |ELEN |RSEN |PLED | DTR | RTS |
+ * | out | out | out | out | out | out | out | out |
+ * +-----+-----+-----+-----+-----+-----+-----+-----+
+ */
+
+#define HW_RTS_BIT		0x01	/* RS-232 RTS */
+#define HW_DTR_BIT		0x02	/* RS-232 DTR */
+#define HW_PLED_BIT		0x04	/* Disable power LED */
+#define HW_RSEN_BIT		0x08	/* Enable RS-232 driver */
+#define	HW_ELEN_BIT		0x10	/* Enable backlight */
+#define HW_IREN_BIT		0x20	/* Enable IR receiver */
+#define	HW_BBLD_BIT		0x40	/* Apply load to backup battery */
+#define	HW_ADICT_BIT		0x80	/* Set audio circuit to "dictaphone" */
+
+/*
+ * Port D
+ *
+ * +--7--+--6--+--5--+--4--+--3--+--2--+--1--+--0--+
+ * | X2  | VLL |TRIX2|SLED |DORSW| DON |AMPEN|CDEN |
+ * |in/ou| out | n/a | out | out | out | out | out |
+ * +-----+-----+-----+-----+-----+-----+-----+-----+
+ */
+
+#define HW_CDEN_BIT		0x01	/* CODEC enable */
+#define HW_AMPEN_BIT		0x02	/* Audio Amplifier Enable */
+#define HW_DON_BIT		0x04	/* Display On */
+#define HW_SLED_BIT		0x10	/* Turns Status LED ON */
+#define HW_VLL_BIT		0x40	/* LCD Logic Rail */
+#define HW_X2_BIT		0x80	/* Pen Down Detect Line */
+
+/*
+ * Port E
+ *
+ * +--3--+--2--+--1--+--0--+
+ * |Y1EN |X1EN |Y2EN |X2EN |
+ * | out | out | out | out |
+ * +-----+-----+-----+-----+
+ */
+
+#define HW_X2EN_BIT		0x01	/* Digitiser X2 Drive */
+#define HW_Y2EN_BIT		0x02	/* Digitiser Y2 Drive */
+#define HW_X1EN_BIT		0x04	/* Digitiser X1 Drive */
+#define HW_Y1EN_BIT		0x08	/* Digitiser Y1 Drive */
+
+/*
+ * ADC channels
+ */
+
+#define ADC_DIG_X	ADC1213X_CHAN0	/* Digitiser Y */
+#define	ADC_DIG_Y	ADC1213X_CHAN1	/* Digitiser X */
+#define ADC_VBATT	ADC1213X_CHAN2	/* Primary Battery Voltage */
+#define ADC_VBACKUP	ADC1213X_CHAN3	/* Back-up Battery Voltage */
+#define	ADC_VREF	ADC1213X_CHAN4	/* Reference Voltage */
+#define	ADC_VPC		ADC1213X_CHAN5	/* Vpc/2 - CF power rail Voltage */
+#define	ADC_VDC		ADC1213X_CHAN6	/* DC in (/2.5) */
+#define	ADC_VPP		ADC1213X_CHAN7	/* VPP (/4) */
+
+/*
+ * ADC timing
+ */
+
+#define ADC1213X_T_CK	/*4*/5	/* SMPCLK, 256 kHz */
+#define ADC1213X_T_SK	/*8*/9	/* ADCCLK, 128 kHz */
+
+#define SSI_SPD      ADCS_256
+
+#endif
diff -uNr linux/include/asm-arm/arch-clps711x/irqs.h linux-2.4.7/include/asm-arm/arch-clps711x/irqs.h
--- linux/include/asm-arm/arch-clps711x/irqs.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/irqs.h	Wed Apr 17 03:39:12 2002
@@ -37,6 +37,11 @@
 #define INT1_IRQS			(0x0000fff0)
 #define INT1_ACK_IRQS			(0x00004f10)
 
+#if defined(CONFIG_ARCH_CLPS7110)
+
+#define NR_IRQS                         16
+
+#else
 /*
  * Interrupts from INTSR2
  */
@@ -51,3 +56,4 @@
 
 #define NR_IRQS                         30
 
+#endif
diff -uNr linux/include/asm-arm/arch-clps711x/memory.h linux-2.4.7/include/asm-arm/arch-clps711x/memory.h
--- linux/include/asm-arm/arch-clps711x/memory.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/memory.h	Wed Apr 17 03:39:11 2002
@@ -38,6 +38,55 @@
 #define PAGE_OFFSET	(0xc0000000UL)
 #define PHYS_OFFSET	(0xc0000000UL)
 
+#if defined(CONFIG_CLPS7110_PSION)
+
+/*
+ *  Psion Series 5 physical memory map
+ *
+ *  0xc0000000 size 512k
+ *  0xc0100000 size 512k
+ *  0xc0400000 size 512k
+ *  0xc0500000 size 512k
+ *  0xc1000000 size 512k
+ *  0xc1100000 size 512k
+ *  0xc1400000 size 512k
+ *  0xc1500000 size 512k
+ *  0xd0000000 size 512k
+ *  0xd0100000 size 512k
+ *  0xd0400000 size 512k
+ *  0xd0500000 size 512k
+ *  0xd1000000 size 512k
+ *  0xd1100000 size 512k
+ *  0xd1400000 size 512k
+ *  0xd1500000 size 512k
+ *
+ *  phys addr bits: 110n 000n 0n0n 0xxx xxxx xxxx xxxx xxxx
+ *  virt addr bits: 1100 0000 0nnn nxxx xxxx xxxx xxxx xxxx
+ */
+
+#define MEM_SIZE (0x00800000UL) /* 8 Mb for Psion S5 */
+
+#define __virt_to_phys__is_a_macro
+#define __virt_to_phys(x)	(((x) & 0xc007ffff) | \
+				(((x) & 0x00400000) << 6) | \
+				(((x) & 0x00200000) << 3) | \
+				(((x) & 0x00100000) << 2) | \
+				(((x) & 0x00080000) << 1))
+
+#define __phys_to_virt__is_a_macro
+#define __phys_to_virt(x)	(((x) & 0xc007ffff) | \
+				(((x) & 0x10000000) >> 6) | \
+				(((x) & 0x01000000) >> 3) | \
+				(((x) & 0x00400000) >> 2) | \
+				(((x) & 0x00100000) >> 1))
+
+/*
+ * __bidx_2_pidx makes page index from index to bootmem map
+ */
+#define __bidx_2_pidx(x) (__phys_to_virt((x) << PAGE_SHIFT) >> PAGE_SHIFT)
+
+#else
+
 /*
  * On integrator, the dram is contiguous
  */
@@ -46,6 +95,8 @@
 #define __phys_to_virt__is_a_macro
 #define __phys_to_virt(ppage) ((ppage) + PAGE_OFFSET - PHYS_OFFSET)
 
+#endif
+
 /*
  * Virtual view <-> DMA view memory address translations
  * virt_to_bus: Used to translate the virtual address to an
@@ -53,6 +104,7 @@
  * bus_to_virt: Used to convert an address for DMA operations
  *              to an address that the kernel can use.
  */
+
 #define __virt_to_bus__is_a_macro
 #define __virt_to_bus(x)	((x) - PAGE_OFFSET)
 #define __bus_to_virt__is_a_macro
diff -uNr linux/include/asm-arm/arch-clps711x/pcmcia.h linux-2.4.7/include/asm-arm/arch-clps711x/pcmcia.h
--- linux/include/asm-arm/arch-clps711x/pcmcia.h	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/include/asm-arm/arch-clps711x/pcmcia.h	Fri Aug 10 00:21:08 2001
@@ -0,0 +1,70 @@
+/*
+ * linux/include/asm/arch/pcmcia.h
+ *
+ * Copyright (C) 2000 John G Dorsey <john+@cs.cmu.edu>
+ *
+ * This file contains definitions for the low-level Psion Series 5 kernel PCMCIA
+ * interface. Please see linux/Documentation/arm/SA1100/PCMCIA for details.
+ */
+
+#ifndef _ASM_ARCH_PCMCIA
+#define _ASM_ARCH_PCMCIA
+
+
+/* Ideally, we'd support up to MAX_SOCK sockets, but the SA-1100 only
+ * has support for two. This shows up in lots of hardwired ways, such
+ * as the fact that MECR only has enough bits to configure two sockets.
+ * Since it's so entrenched in the hardware, limiting the software
+ * in this way doesn't seem too terrible.
+ */
+#define PSION_S5_PCMCIA_MAX_SOCK   (1)
+
+
+#ifndef __ASSEMBLY__
+
+struct pcmcia_init {
+  void (*handler)(int irq, void *dev, struct pt_regs *regs);
+};
+
+struct pcmcia_state {
+  unsigned detect: 1,
+            ready: 1,
+             bvd1: 1,
+             bvd2: 1,
+           wrprot: 1,
+            vs_3v: 1,
+            vs_Xv: 1;
+};
+
+struct pcmcia_state_array {
+  unsigned int size;
+  struct pcmcia_state *state;
+};
+
+struct pcmcia_configure {
+  unsigned sock: 8,
+            vcc: 8,
+            vpp: 8,
+         output: 1,
+        speaker: 1,
+          reset: 1;
+};
+
+struct pcmcia_irq_info {
+  unsigned int sock;
+  unsigned int irq;
+};
+
+struct pcmcia_low_level {
+  int (*init)(struct pcmcia_init *);
+  int (*shutdown)(void);
+  int (*socket_state)(struct pcmcia_state_array *);
+  int (*get_irq_info)(struct pcmcia_irq_info *);
+  int (*configure_socket)(const struct pcmcia_configure *);
+};
+
+extern struct pcmcia_low_level *pcmcia_low_level;
+
+#endif  /* __ASSEMBLY__ */
+
+#endif
diff -uNr linux/include/asm-arm/arch-clps711x/system.h linux-2.4.7/include/asm-arm/arch-clps711x/system.h
--- linux/include/asm-arm/arch-clps711x/system.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/system.h	Wed Apr 17 04:02:24 2002
@@ -20,7 +20,7 @@
 #ifndef __ASM_ARCH_SYSTEM_H
 #define __ASM_ARCH_SYSTEM_H
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
 static void arch_idle(void)
 {
diff -uNr linux/include/asm-arm/arch-clps711x/time.h linux-2.4.7/include/asm-arm/arch-clps711x/time.h
--- linux/include/asm-arm/arch-clps711x/time.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/time.h	Wed Apr 17 04:02:43 2002
@@ -19,12 +19,12 @@
  */
 #include <asm/system.h>
 #include <asm/leds.h>
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
 /*
  * IRQ handler for the timer
  */
-static void p720t_timer_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+static void clps711x_timer_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
 	do_leds();
 	do_timer(regs);
@@ -37,7 +37,7 @@
  * 'LATCH' is hwclock ticks (see CLOCK_TICK_RATE in timex.h) per jiffy.
  * 'tick' is usecs per jiffy.
  */
-static unsigned long p720t_gettimeoffset(void)
+static unsigned long clps711x_gettimeoffset(void)
 {
 	unsigned long hwticks;
 	hwticks = LATCH - (clps_readl(TC2D) & 0xffff);	/* since last underflow */
@@ -51,15 +51,20 @@
 {
 	unsigned int syscon;
 
-	gettimeoffset = p720t_gettimeoffset;
+	gettimeoffset = clps711x_gettimeoffset;
 
 	syscon = clps_readl(SYSCON1);
+#if defined(CONFIG_CLPS7110_PSION)
+	syscon |= SYSCON1_TC2M;
+	syscon &= ~SYSCON1_TC2S;	/* use 2KHz for lower power */
+#else
 	syscon |= SYSCON1_TC2S | SYSCON1_TC2M;
+#endif
 	clps_writel(syscon, SYSCON1);
 
 	clps_writel(LATCH-1, TC2D); /* 512kHz / 100Hz - 1 */
 
-	timer_irq.handler = p720t_timer_interrupt;
+	timer_irq.handler = clps711x_timer_interrupt;
 
 	/* 
 	 * Make irqs happen for the system timer
diff -uNr linux/include/asm-arm/arch-clps711x/timex.h linux-2.4.7/include/asm-arm/arch-clps711x/timex.h
--- linux/include/asm-arm/arch-clps711x/timex.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/timex.h	Wed Apr 17 03:39:12 2002
@@ -20,4 +20,8 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
+#if defined(CONFIG_CLPS7110_PSION)
+#define CLOCK_TICK_RATE 2000	/* 2 KHz */
+#else
 #define CLOCK_TICK_RATE 512000
+#endif
diff -uNr linux/include/asm-arm/arch-clps711x/uncompress.h linux-2.4.7/include/asm-arm/arch-clps711x/uncompress.h
--- linux/include/asm-arm/arch-clps711x/uncompress.h	Fri Aug  3 05:40:04 2001
+++ linux-2.4.7/include/asm-arm/arch-clps711x/uncompress.h	Fri Aug 10 02:54:01 2001
@@ -19,15 +19,15 @@
  */
 #include <asm/arch/io.h>
 #include <asm/arch/hardware.h>
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
-#undef CLPS7111_BASE
-#define CLPS7111_BASE CLPS7111_PHYS_BASE
+#undef CLPS711X_BASE
+#define CLPS711X_BASE CLPS711X_PHYS_BASE
 
 #define __raw_readl(p)		(*(unsigned long *)(p))
 #define __raw_writel(v,p)	(*(unsigned long *)(p) = (v))
 
-#if 1
+#if defined(CONFIG_ARCH_P720T)
 #define SYSFLGx	SYSFLG2
 #define UARTDRx	UARTDR2
 #else
diff -uNr linux/include/asm-arm/hardware/clps711x.h linux-2.4.7/include/asm-arm/hardware/clps711x.h
--- linux/include/asm-arm/hardware/clps711x.h	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/include/asm-arm/hardware/clps711x.h	Wed Apr 17 03:43:22 2002
@@ -0,0 +1,190 @@
+/*
+ *  linux/include/asm-arm/hardware/clps7111.h
+ *
+ *  This file contains the hardware definitions of the CLPS711X internal
+ *  registers.
+ *
+ *  Copyright (C) 2000 Deep Blue Solutions Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#ifndef __ASM_HARDWARE_CLPS711X_H
+#define __ASM_HARDWARE_CLPS711X_H
+
+#define CLPS711X_PHYS_BASE	(0x80000000)
+
+#define CLPS711X_LCD_MEM_BASE		(0xC0000000)
+#define CLPS711X_LCD_MEM_SIZE		(0x0001ffff) /* 128k */
+
+#ifndef __ASSEMBLY__
+#define clps_readb(off)		__raw_readb(CLPS711X_BASE + (off))
+#define clps_readl(off)		__raw_readl(CLPS711X_BASE + (off))
+#define clps_writeb(val,off)	__raw_writeb(val, CLPS711X_BASE + (off))
+#define clps_writel(val,off)	__raw_writel(val, CLPS711X_BASE + (off))
+#endif
+
+#define PADR		(0x0000)
+#define PBDR		(0x0001)
+#define PDDR		(0x0003)
+#define PADDR		(0x0040)
+#define PBDDR		(0x0041)
+#define PDDDR		(0x0043)
+#define PEDR		(0x0080)
+#define PEDDR		(0x00c0)
+#define SYSCON1		(0x0100)
+#define SYSFLG1		(0x0140)
+#define MEMCFG1		(0x0180)
+#define MEMCFG2		(0x01c0)
+#define DRFPR		(0x0200)
+#define INTSR1		(0x0240)
+#define INTMR1		(0x0280)
+#define LCDCON		(0x02c0)
+#define TC2D		(0x0340)
+#define RTCDR		(0x0380)
+#define RTCMR		(0x03c0)
+#define PMPCON		(0x0400)
+#define CODR		(0x0440)
+#define UARTDR1		(0x0480)
+#define UBRLCR1		(0x04c0)
+#define SYNCIO		(0x0500)
+#define PALLSW		(0x0540)
+#define PALMSW		(0x0580)
+#define STFCLR		(0x05c0)
+#define BLEOI		(0x0600)
+#define MCEOI		(0x0640)
+#define TEOI		(0x0680)
+#define TC1EOI		(0x06c0)
+#define TC2EOI		(0x0700)
+#define RTCEOI		(0x0740)
+#define UMSEOI		(0x0780)
+#define COEOI		(0x07c0)
+#define HALT		(0x0800)
+#define STDBY		(0x0840)
+
+
+/* common bits: SYSCON1 / SYSCON2 */
+#define SYSCON_UARTEN		(1 << 8)
+
+#define SYSCON1_KBDSCAN(x)	((x) & 15)
+#define SYSCON1_KBDSCANMASK	(15)
+#define SYSCON1_TC1M		(1 << 4)
+#define SYSCON1_TC1S		(1 << 5)
+#define SYSCON1_TC2M		(1 << 6)
+#define SYSCON1_TC2S		(1 << 7)
+#define SYSCON1_UART1EN		SYSCON_UARTEN
+#define SYSCON1_BZTOG		(1 << 9)
+#define SYSCON1_BZMOD		(1 << 10)
+#define SYSCON1_DBGEN		(1 << 11)
+#define SYSCON1_LCDEN		(1 << 12)
+#define SYSCON1_CDENTX		(1 << 13)
+#define SYSCON1_CDENRX		(1 << 14)
+#define SYSCON1_SIREN		(1 << 15)
+#define SYSCON1_ADCKSEL(x)	(((x) & 3) << 16)
+#define SYSCON1_ADCKSEL_MASK	(3 << 16)
+#define SYSCON1_EXCKEN		(1 << 18)
+#define SYSCON1_WAKEDIS		(1 << 19)
+#define SYSCON1_IRTXM		(1 << 20)
+
+/* common bits: SYSFLG1 / SYSFLG2 */
+#define SYSFLG_UBUSY		(1 << 11)
+#define SYSFLG_URXFE		(1 << 22)
+#define SYSFLG_UTXFF		(1 << 23)
+
+#define SYSFLG1_MCDR		(1 << 0)
+#define SYSFLG1_DCDET		(1 << 1)
+#define SYSFLG1_WUDR		(1 << 2)
+#define SYSFLG1_WUON		(1 << 3)
+#define SYSFLG1_CTS		(1 << 8)
+#define SYSFLG1_DSR		(1 << 9)
+#define SYSFLG1_DCD		(1 << 10)
+#define SYSFLG1_UBUSY		SYSFLG_UBUSY
+#define SYSFLG1_NBFLG		(1 << 12)
+#define SYSFLG1_RSTFLG		(1 << 13)
+#define SYSFLG1_PFFLG		(1 << 14)
+#define SYSFLG1_CLDFLG		(1 << 15)
+#define SYSFLG1_URXFE		SYSFLG_URXFE
+#define SYSFLG1_UTXFF		SYSFLG_UTXFF
+#define SYSFLG1_CRXFE		(1 << 24)
+#define SYSFLG1_CTXFF		(1 << 25)
+#define SYSFLG1_SSIBUSY		(1 << 26)
+#define SYSFLG1_ID		(1 << 29)
+
+#define LCDCON_GSEN		(1 << 30)
+#define LCDCON_GSMD		(1 << 31)
+
+#if !defined(CONFIG_ARCH_CLPS7110)
+
+#define FBADDR		(0x1000)
+#define SYSCON2		(0x1100)
+#define SYSFLG2		(0x1140)
+#define INTSR2		(0x1240)
+#define INTMR2		(0x1280)
+#define UARTDR2		(0x1480)
+#define UBRLCR2		(0x14c0)
+#define SS2DR		(0x1500)
+#define SRXEOF		(0x1600)
+#define SS2POP		(0x16c0)
+#define KBDEOI		(0x1700)
+
+#define SYSFLG2_SSRXOF		(1 << 0)
+#define SYSFLG2_RESVAL		(1 << 1)
+#define SYSFLG2_RESFRM		(1 << 2)
+#define SYSFLG2_SS2RXFE		(1 << 3)
+#define SYSFLG2_SS2TXFF		(1 << 4)
+#define SYSFLG2_SS2TXUF		(1 << 5)
+#define SYSFLG2_CKMODE		(1 << 6)
+#define SYSFLG2_UBUSY		SYSFLG_UBUSY
+#define SYSFLG2_URXFE		SYSFLG_URXFE
+#define SYSFLG2_UTXFF		SYSFLG_UTXFF
+
+
+#define SYSCON2_SERSEL		(1 << 0)
+#define SYSCON2_KBD6		(1 << 1)
+#define SYSCON2_DRAMZ		(1 << 2)
+#define SYSCON2_KBWEN		(1 << 3)
+#define SYSCON2_SS2TXEN		(1 << 4)
+#define SYSCON2_PCCARD1		(1 << 5)
+#define SYSCON2_PCCARD2		(1 << 6)
+#define SYSCON2_SS2RXEN		(1 << 7)
+#define SYSCON2_UART2EN		SYSCON_UARTEN
+#define SYSCON2_SS2MAEN		(1 << 9)
+#define SYSCON2_OSTB		(1 << 12)
+#define SYSCON2_CLKENSL		(1 << 13)
+#define SYSCON2_BUZFREQ		(1 << 14)
+
+#endif /* !defined(CONFIG_ARCH_CLPS7110) */
+
+/* common bits: UARTDR1 / UARTDR2 */
+#define UARTDR_FRMERR		(1 << 8)
+#define UARTDR_PARERR		(1 << 9)
+#define UARTDR_OVERR		(1 << 10)
+
+/* common bits: UBRLCR1 / UBRLCR2 */
+#define UBRLCR_BAUD_MASK	((1 << 12) - 1)
+#define UBRLCR_BREAK		(1 << 12)
+#define UBRLCR_PRTEN		(1 << 13)
+#define UBRLCR_EVENPRT		(1 << 14)
+#define UBRLCR_XSTOP		(1 << 15)
+#define UBRLCR_FIFOEN		(1 << 16)
+#define UBRLCR_WRDLEN5		(0 << 17)
+#define UBRLCR_WRDLEN6		(1 << 17)
+#define UBRLCR_WRDLEN7		(2 << 17)
+#define UBRLCR_WRDLEN8		(3 << 17)
+#define UBRLCR_WRDLEN_MASK	(3 << 17)
+
+#define SYNCIO_SMCKEN		(1 << 13)
+#define SYNCIO_TXFRMEN		(1 << 14)
+
+#endif /* __ASM_HARDWARE_CLPS711X_H */
diff -uNr linux/include/asm-arm/page.h linux-2.4.7/include/asm-arm/page.h
--- linux/include/asm-arm/page.h	Sun Aug 13 20:54:15 2000
+++ linux-2.4.7/include/asm-arm/page.h	Wed Apr 17 03:39:11 2002
@@ -91,8 +91,12 @@
 #define __va(x)			((void *)__phys_to_virt((unsigned long)(x)))
 
 #ifndef CONFIG_DISCONTIGMEM
+#if defined(CONFIG_CLPS7110_PSION)
+#define virt_to_page(kaddr)	(mem_map + ((((unsigned long)(kaddr)) - PAGE_OFFSET) >> PAGE_SHIFT))
+#else
 #define virt_to_page(kaddr)	(mem_map + (__pa(kaddr) >> PAGE_SHIFT) - \
 				 (PHYS_OFFSET >> PAGE_SHIFT))
+#endif
 #define VALID_PAGE(page)	((page - mem_map) < max_mapnr)
 #endif
 
diff -uNr linux/include/asm-arm/setup.h linux-2.4.7/include/asm-arm/setup.h
--- linux/include/asm-arm/setup.h	Fri Aug  3 05:40:05 2001
+++ linux-2.4.7/include/asm-arm/setup.h	Wed Apr 17 03:43:30 2002
@@ -246,7 +246,11 @@
 /*
  * Memory map description
  */
+#if defined(CONFIG_CLPS7110_PSION)
+#define NR_BANKS 16
+#else
 #define NR_BANKS 8
+#endif
 
 struct meminfo {
 	int nr_banks;
